//+------------------------------------------------------------------+
//|                                                       vortex.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red

//
//
//
//
//

extern int    VortexPeriod  = 14;
extern bool   arrowVisible  = false;
extern int    arrowCodeUp   = 221;
extern int    arrowCodeDown = 222;
extern int    arrowSize     = 1;
extern int    arrowGap      = 20;
extern color  colorUp       = LimeGreen;
extern color  colorDown     = Orange;
extern string UniqueID      = "Vortex1";

//
//
//
//
//

double vopBuffer[];
double vomBuffer[];
double vmpBuffer[];
double vmmBuffer[];
double rngBuffer[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,vopBuffer);
   SetIndexBuffer(1,vomBuffer);
   SetIndexBuffer(2,vmpBuffer);
   SetIndexBuffer(3,vmmBuffer);
   SetIndexBuffer(4,rngBuffer);
   SetIndexBuffer(5,trend);
   IndicatorShortName("Vortex ( "+VortexPeriod+")");         
   return(0);
}

int deinit()
{
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i); if (StringFind(name,UniqueID+":")==0) ObjectDelete(name);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars < 0)   return(-1);
   if(counted_bars > 0)   counted_bars--;
           limit = MathMax(Bars-counted_bars,Bars-2);
           int window = 0; if (!arrowVisible) window=-1;
           
   //
   //
   //
   //
   //

      for(i = limit; i >= 0; i--)
      {
         rngBuffer[i] = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         vmpBuffer[i] = MathAbs(High[i] - Low[i+1]);
         vmmBuffer[i] = MathAbs(Low[i] - High[i+1]);
         vopBuffer[i] = EMPTY_VALUE;
         vomBuffer[i] = EMPTY_VALUE;

         if ((Bars-i)<VortexPeriod) continue;
         
         //
         //
         //
         //
         //
         
            double vmpSum = 0;
            double vmmSum = 0;
            double rngSum = 0;
            for (int k=0; k<VortexPeriod; k++)
            {
               vmpSum += vmpBuffer[i+k];
               vmmSum += vmmBuffer[i+k];
               rngSum += rngBuffer[i+k];
            }
            if (rngSum !=0)
            {
               vopBuffer[i] = vmpSum/rngSum;
               vomBuffer[i] = vmmSum/rngSum;
            }
            trend[i] = trend[i+1];
               if (vopBuffer[i]>vomBuffer[i]) trend[i]= 1;
               if (vopBuffer[i]<vomBuffer[i]) trend[i]=-1;
               if (window>-1) manageArrow(window,i);
      }

   //
   //
   //
   //
   //

   return(0);      
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int window, int i)
{
      string name = UniqueID+":"+Time[i]; 
         ObjectDelete(name);
         
         //
         //
         //
         //
         //
         
         if (trend[i]==trend[i+1]) return;
            color  theColor = colorUp;
            int    theArrow = arrowCodeUp;
            double thePrice = Low[i]-iATR(NULL,0,20,i)*0.5;
               if (trend[i] == -1)
               {
                  theColor = colorDown;
                  theArrow = arrowCodeDown;
                  thePrice = High[i]+iATR(NULL,0,20,i)*0.75;
               }
         ObjectCreate(name,OBJ_ARROW,window,0,0);
            ObjectSet(name,OBJPROP_ARROWCODE,theArrow);
            ObjectSet(name,OBJPROP_COLOR    ,theColor);
            ObjectSet(name,OBJPROP_TIME1    ,Time[i]);
            ObjectSet(name,OBJPROP_PRICE1   ,thePrice);
            ObjectSet(name,OBJPROP_WIDTH    ,arrowSize);
}

